//+------------------------------------------------------------------+
//|                                                   quantile bands |
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrPaleVioletRed
#property indicator_color4  clrDeepSkyBlue
#property indicator_color5  clrPaleVioletRed
#property indicator_color6  clrPaleVioletRed
#property indicator_color7  clrDimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame         = PERIOD_CURRENT;
extern int                Periods           = 35;
extern ENUM_APPLIED_PRICE Price             = PRICE_TYPICAL;
extern double             UpperBandPercent  = 90;
extern double             LowerBandPercent  = 10;
extern double             MedianBandPercent = 50;
extern bool               Interpolate       = true;

//
//
//
//
//

double bufferUp[];
double bufferUpa[];
double bufferUpb[];
double bufferDn[];
double bufferDna[];
double bufferDnb[];
double bufferMe[];
double trendsa[],trendsb[];
double workPrices[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,bufferUp);
   SetIndexBuffer(1,bufferUpa);
   SetIndexBuffer(2,bufferUpb);
   SetIndexBuffer(3,bufferDn);
   SetIndexBuffer(4,bufferDna);
   SetIndexBuffer(5,bufferDnb);
   SetIndexBuffer(6,bufferMe);
   SetIndexBuffer(6,bufferMe);
   SetIndexBuffer(7,trendsa);
   SetIndexBuffer(8,trendsb);
   SetIndexBuffer(9,workPrices);
   

   //
   //
   //
   //
   //
         
      Periods           = MathMax(Periods,1);
      UpperBandPercent  = MathMax(MathMin(UpperBandPercent ,100),0);
      LowerBandPercent  = MathMax(MathMin(LowerBandPercent ,100),0);
      MedianBandPercent = MathMax(MathMin(MedianBandPercent,100),0);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(TimeFrame)+" Quantile bands ("+Periods+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { bufferUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==_Period)
   {
      if (trendsa[limit]==-1) CleanPoint(limit,bufferUpa,bufferUpb);
      if (trendsb[limit]==-1) CleanPoint(limit,bufferDna,bufferDnb);
      for(int i=limit; i>=0; i--)
      {
         workPrices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            bufferUp[i] = iQuantile(Periods,UpperBandPercent ,i);
            bufferDn[i] = iQuantile(Periods,LowerBandPercent ,i);
            bufferMe[i] = iQuantile(Periods,MedianBandPercent,i);
            trendsa[i] = trendsa[i+1];
            trendsb[i] = trendsb[i+1];

               //
               //
               //
               //
               //
                           
               if (bufferUp[i]>bufferUp[i+1]) trendsa[i] = 1;
               if (bufferUp[i]<bufferUp[i+1]) trendsa[i] =-1;
               if (bufferDn[i]>bufferDn[i+1]) trendsb[i] = 1;
               if (bufferDn[i]<bufferDn[i+1]) trendsb[i] =-1;
                  bufferUpa[i] = EMPTY_VALUE;
                  bufferUpb[i] = EMPTY_VALUE;
                  bufferDna[i] = EMPTY_VALUE;
                  bufferDnb[i] = EMPTY_VALUE;
                     if (trendsa[i] == -1) PlotPoint(i,bufferUpa,bufferUpb,bufferUp);
                     if (trendsb[i] == -1) PlotPoint(i,bufferDna,bufferDnb,bufferDn);
      }         
      return(0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (trendsa[limit]==-1) CleanPoint(limit,bufferUpa,bufferUpb);
   if (trendsb[limit]==-1) CleanPoint(limit,bufferDna,bufferDnb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         bufferUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,0,y);
         bufferDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,3,y);
         bufferMe[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,6,y);
         trendsa[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,7,y);
         trendsb[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,8,y);
         bufferUpa[i] = EMPTY_VALUE;
         bufferUpb[i] = EMPTY_VALUE;
         bufferDna[i] = EMPTY_VALUE;
         bufferDnb[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               bufferUp[i+k] = bufferUp[i] +(bufferUp[i+n]-bufferUp[i])*k/n;
               bufferDn[i+k] = bufferDn[i] +(bufferDn[i+n]-bufferDn[i])*k/n;
               bufferMe[i+k] = bufferMe[i] +(bufferMe[i+n]-bufferMe[i])*k/n;
            }
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      if (trendsa[i]==-1) PlotPoint(i,bufferUpa,bufferUpb,bufferUp);
      if (trendsb[i]==-1) PlotPoint(i,bufferDna,bufferDnb,bufferDn);
   }
   return(0);         
   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double quantileArray[];
double iQuantile(int period, double qp, int i)
{
   if (ArraySize(quantileArray)!=period) ArrayResize(quantileArray,period);
                  for(int k=0; k<period && (i+k)<Bars; k++) quantileArray[k] = workPrices[i+k];
       ArraySort(quantileArray);

   //
   //
   //
   //
   //
   
   double index = (period-1)*qp/100.00;
   int    ind   = index;
   double delta = index - ind;
   if (ind == NormalizeDouble(index,5))
         return(            quantileArray[ind]);
   else  return((1.0-delta)*quantileArray[ind]+delta*quantileArray[ind+1]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}